# plot.gnu:  gnuplot commands to plot data created by run script
#
# Part of example code for "Drill Bits" column in ACM Queue magazine
# November/December 2023,  https://queue.acm.org/DrillBits
#
# Copyright (C) 2023  Terence Kelly
# Contact:  tpkelly @ { acm.org, cs.princeton.edu, eecs.umich.edu }
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.

set border 3
set xtics nomirror
set ytics nomirror
set logscale x
set logscale y
set style data linespoints
set xrange [512:67108864]
set xtics ( \
"2^{10}"1024, \
"2^{11}"2048, \
"2^{12}"4096, \
"2^{13}"8192, \
"2^{14}"16384, \
"2^{15}"32768, \
"2^{16}"65536, \
"2^{17}"131072, \
"2^{18}"262144, \
"2^{19}"524288, \
"2^{20}"1048576, \
"2^{21}"2097152, \
"2^{22}"4194304, \
"2^{23}"8388608, \
"2^{24}"16777216, \
"2^{25}"33554432 )
set xlabel "number of inmates"
set ylabel  "time in seconds" #             textcolor rgbcolor "red"
set key top left
set term pdf enhanced color
set output "plot.pdf"

plot \
"< gawk '/^TIME /{print $3, $4/1000000000}' hashdel.out"    t "hashdel"    pt 6 lt 1, \
"< gawk '/^TIME /{print $3, $4/1000000000}' hashflag.out"   t "hashflag"   pt 4 lt 2, \
"< gawk '/^TIME /{print $3, $4/1000000000}' triangular.out" t "triangular" pt 8 lt 7

