/* Utility functions used by several programs (interface).

   Part of example code for "Drill Bits" column in ACM Queue magazine
   November/December 2023,  https://queue.acm.org/DrillBits

   Copyright (C) 2023  Terence Kelly
   Contact:  tpkelly @ { acm.org, cs.princeton.edu, eecs.umich.edu }

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU Affero General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Affero General Public License for more details.

   You should have received a copy of the GNU Affero General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
*/

#ifndef UTIL_H_INCLUDED
#define UTIL_H_INCLUDED

#define SAUX(s) #s
#define STRINGIFY(s) SAUX(s)
#define COORDS __FILE__ ":" STRINGIFY(__LINE__) ":  "

#ifdef __cplusplus
#define P(...)  cout           << __VA_ARGS__ << endl
#define PE(...) cerr << COORDS << __VA_ARGS__ << endl
#else
#define P       (void) printf
#define PE(...) (void)fprintf(stderr, COORDS __VA_ARGS__)
#endif

#define BAIL(...) \
  do { PE(__VA_ARGS__); exit(EXIT_FAILURE); } while (0)

#ifdef __cplusplus
extern "C"
{
#endif

extern uint64_t Tns(void);

extern uintmax_t s2u(const char *s);

#ifdef __cplusplus
}
#endif

#endif  // UTIL_H_INCLUDED

